package edu.udo.cs.ie.cowbots.bdi.brf;

import edu.udo.cs.ie.cowbots.util.GridMap;
import edu.udo.cs.ie.cowbots.logic.ELPLiteral;
import java.util.List;

/**
 * the MapOperator models the interface for any knowledge
 * operator that intends to operate on environmental
 * information based upon the gridmap data structure.
 *  
 * @author Thomas
 *
 */
public interface MapOperator {

	/**
	 * initialization routine, any operator
	 * has to accept the map instance provided
	 * as the first parameter
	 * 
	 * @param map	environment instance
	 * 
	 */
	public void assignMap(GridMap map);
	
	/**
	 * returns the explorations an agent
	 * made at the current turn. respecting
	 * the massim scenario, an operator
	 * implementing this interface is expected
	 * to provide any cow seen the current
	 * turn, too.
	 * 
	 * @return list of new perceptions
	 */
	public List<ELPLiteral> getExploredCells();
	
	
	/**
	 * returns the gridmap associated with the
	 * knowledge operator implementing this
	 * interface
	 * @return	operator's gridmap instance
	 */
	public GridMap getGridMap();
		
}
