package edu.udo.cs.ie.cowbots.bdi.brf.operators;

import jason.asSyntax.Literal;
import edu.udo.cs.ie.cowbots.bdi.brf.BeliefBase;
import edu.udo.cs.ie.cowbots.bdi.brf.BeliefSet;
import edu.udo.cs.ie.cowbots.bdi.brf.IKnowledgeOperator;
import edu.udo.cs.ie.cowbots.bdi.brf.InformationObject;
import edu.udo.cs.ie.cowbots.logic.ELPLiteral;
import edu.udo.cs.ie.cowbots.logic.ELP;
import edu.udo.cs.ie.cowbots.logic.ELPRule;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Iterator;

import org.w3c.dom.Element;

/**
 * a knowledge operator that adds new information
 * objects by expansion. 
 * 
 * @author Thomas, Boguslaw
 */
public class ExpansionOperator implements IKnowledgeOperator {

	private List<InformationObject> beliefBaseSequence; 
	
	public ExpansionOperator()
	{
		//beliefBaseSequenz = new ArrayList<InformationObject>();
	}

	
	public boolean update(List<InformationObject> updates, BeliefBase belbase) {
		List<InformationObject> bb = belbase.getOperatorIO(this);
		beliefBaseSequence = bb;
		for (InformationObject io : updates) {
			bb.add(io);
		}
		return updates.size() > 0;
	}

	
	@Override
	public void init(Element config) {
		// TODO Auto-generated method stub
		
	}


	@Override
	public void deleteFacts(Set<ELPLiteral> toDel) {
		if (this.beliefBaseSequence == null)
			return;

		// inspect all io
		Iterator<InformationObject> ioIter = beliefBaseSequence.iterator();
		while (ioIter.hasNext()) {
			InformationObject io = ioIter.next();
			ELP e = io.getELP();
			if (e.nRules() == 1) {
				ELPRule r = e.getRule(0);
				if (r.isFact()) {
					if (toDel.contains( r.getHead(0) ))
						ioIter.remove();
				}				
			}
		}
	}


	@Override
	public void processBeliefSet(BeliefSet bs, BeliefBase base) {
		// default expansion does not process the belief set at
		// all.
	}


	@Override
	public ELP getStateProgram() {
		return null;
	}


	@Override
	public void reset() {
		this.beliefBaseSequence.clear();
	}
	
}
