package edu.udo.cs.ie.cowbots.bdi.desgen;

import jason.asSyntax.Literal;

import java.util.List;

/**
 * Interface for any class which represents an agents desire
 * state. Extending the SortedSets ensures that every desire
 * can only appear once in an agents desirestate.
 * Furthermore it provides easy access to highest motivated
 * desire.
 * 
 * @author dhoelzgen
 *
 */
public interface IDesireState extends List<CDesire> {

	int getIntensityByUniqueName(Literal uniqueName);
	
	CDesire getMostMotivatedDesire();
}
