package edu.udo.cs.ie.cowbots.bdi.desgen;

import java.util.List;
import java.util.SortedSet;

import edu.udo.cs.ie.cowbots.bdi.brf.IEpistemicState;

/**
 * Interface for any class which represents an agents
 * motive. It is used for generating new desires given
 * the agents current beliefs.
 * 
 * @author dhoelzgen
 *
 */
public interface IMotive {

	/**
	 * Returns the unique name of the motive.
	 * 
	 * @return The motivs unique name
	 */
	public String getUniqueName();
	
	/**
	 * Generates new desires based on the agents current
	 * beliefs, despite of the current agents motives because
	 * existing motives will not be replaced.
	 * 
	 * @param Current agents beliefs
	 * @return A set of new desires
	 */
	public List<CDesire> generateDesire(IEpistemicState bel); 
	
}
