package edu.udo.cs.ie.cowbots.elpParser.dlp;

import jason.stdlib.term2string;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * this class delegate either a term or a list of terms which is detail description about a predicate.
 * @author Sebastian, Wei
 */

public class DLPTermList {

	private List<DLPTerm> terms;
	
	public DLPTermList(){
		terms = new ArrayList<DLPTerm>();
	}
	
	public DLPTermList(List<DLPTerm> terms){
		this.terms = terms;
	}
	
	public void addTermList(List<DLPTerm> terms){
		this.terms.addAll(terms);
	}
	
	public DLPTerm getTerm(int i){
		return terms.get(i);
	}
	
	/**
	 * feed actual terms length back
	 * @return number of terms {@link Integer}
	 */
	
	public int getListSize(){
		return terms.size();
	}
	
	/**
	 * whether there is a arithmetic operator.
	 * @param t a term {@link DLPTerm}
	 * @return {@link Boolean}
	 */
	public boolean isArithOperator(DLPTerm t){		
		return t.isArithOP();		
	}
	
	/**
	 * whether there is a comparative operator.
	 * @param t a term {@link DLPTerm}
	 * @return {@link Boolean}
	 */
	public boolean isCompOperator(DLPTerm t){
		return t.isCompOP();		
	}
	
	/**
	 * given DLP-Terms 
	 * @return terms
	 */
	public List<DLPTerm> getAllTerms(){
		return terms;
	}
	
	/**
	 * overview during parse
	 */
	public void resolve(){
	
	System.out.println("TermList:");
	Iterator<DLPTerm> termsIt = terms.iterator();
	DLPTerm term;
		while (termsIt.hasNext()){
			term = termsIt.next();
			System.out.println("Term: "+term.getName());
			
		}	
	}
	
		
	public String[] toArray(){
		String[] sTerms = new String[terms.size()];
		
		Iterator termsIt = terms.iterator();
		
		int i = 0;
		while (termsIt.hasNext()){
			sTerms[i] = ((DLPTerm)termsIt.next()).getName();
			
			i++;
		}
		
		return sTerms;

	
	}

	
}
