package edu.udo.cs.ie.cowbots.elpParser.dlp;

/**
 * this class products predicate for the atoms of disjunctive extends logic program
 * and used in the DLP parser which is made from javaCC 
 * @author Wei 
 *
 */
public class Predicate {

	String predName;
	Vocabulary vs;
	
	
	public Predicate(){
		
	}
	
	/**
	 * Constructor for predicate objects
	 * @param String
	 */	
	public Predicate(String n){
		
		if ((n == null) | (n == "")){
			System.out.println("the name of predicate is invalid!");
		}
		
		vs = new Vocabulary();
		String renewed = n.trim();
		
		try {
			int tLength = renewed.length();
			
			for(int i = 0; i<tLength; i++ ){
				
				String token = renewed.substring(i, i+1);
				DLPConstant aC = vs.getConstant(token);
				if(aC!=null)
					vs.addConstant(aC);
				else
					continue;				
				
			}			
			predName = n;
			
		} catch (Exception e) {
			// TODO: handle exception
			System.out.println(e.getMessage());
		}
				
	}
	
	public void setName(String s){
		
		predName = s;
		
	}
	
	public String getName(){
		
		return predName;
		
	}
	
	public String toString(){
		
		return predName;
		
	}
	
}
