package edu.udo.cs.ie.cowbots.elpParser.dlp;


import java.util.HashSet;
import java.util.Iterator;

/**
 * this class memories the vocabulary of constants and different predicate
 * its function like a dictionary.
 * 
 * @author Sebastian, Wei
 *
 */

public class Vocabulary {
	
	private HashSet<DLPConstant> constants;
    private HashSet<Predicate> ps;
    
 	/**
 	 *  Default constructor
 	 */
	public Vocabulary(){
		
		constants = new HashSet<DLPConstant>();
		ps = new HashSet<Predicate>();
		
	}
	
	
	public void addPredicate(Predicate p){
		if(!ps.add(p))
		System.out.println("Cann't add this new predicate to dictionary!");
		else
			ps.add(p);
	}
	
	/**
	 * product from a string token to a constant, if this token do exist in the char set.  
	 * @return {@link DLPConstant} actual constant from dictionary
	 */	
	public DLPConstant getConstant(String constantName) {
		Iterator<DLPConstant> constIt =  constants.iterator();
		DLPConstant tempConst, returnConst = null;
		while ((constIt.hasNext()) && (returnConst == null)){
			tempConst = constIt.next();
			if (tempConst.getName().equals(constantName)){
				returnConst = tempConst;
			}			
		}
		
		return returnConst;
	}
	
	/**
	 * product from a string to a predicate, if this string do exist in the predicate set.  
	 * @return 
	 */		
	public Predicate getPredicate(String pName){		
		
		for (Predicate aPred : ps) {
			String predName = aPred.getName();
			
			if(predName.equals(pName))
				return aPred;			
			
		}
				
		return null;
		
	}
	
	public void addConstant(DLPConstant constant){
		constants.add(constant);
	}
	
	/**
	 * this method is only used by DLP parsing and present the stand of constants.	 
	 */	
	public void resolve(){
		System.out.println("Vocabulary:");
		Iterator<DLPConstant> constIt =  constants.iterator();
		while (constIt.hasNext()){
			
			System.out.println("Constants: " + constIt.next().getName());
			
			}
			
	}
	
	
}
