package edu.udo.cs.ie.cowbots.internalActions.Leader;

import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.asSyntax.NumberTerm;
import jason.asSyntax.NumberTermImpl;
import jason.asSyntax.Term;


/**
 * 
 * @author Loewen
 * This internal action is used to determine the coordinates to follow the cow,
 * without to scary away
 * returns Coordinates to walk to
 */
public class followTheCowGently extends DefaultInternalAction {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;	
	private static int DELTA = 2;
	
	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
	throws Exception {
		
		int x= (int) ((NumberTerm) args[0]).solve(); 
		int y= (int) ((NumberTerm) args[1]).solve(); 
		int cowX= (int) ((NumberTerm) args[2]).solve(); 
		int cowY= (int) ((NumberTerm) args[3]).solve();
		int diffX = Math.abs(x-cowX);
		int diffY = Math.abs(y-cowY);
		int myX=x,myY=y;
		if (diffX > DELTA) {
			if (x < cowX) myX = x + (diffX - DELTA);
			else myX = x - (diffX - DELTA);
			if (y < cowY) myY = y + (diffY - DELTA);
			else myY = y - (diffY - DELTA);
		}
		
		
		//System.out.println("Follow coordinates"+myX+" " +myY);
		un.unifies(args[4], new NumberTermImpl(myX));
		un.unifies(args[5], new NumberTermImpl(myY));
		return true;
	}	
	
	
}
