package edu.udo.cs.ie.cowbots.internalActions.experimental2;

import java.awt.Point;

import edu.udo.cs.ie.cowbots.agent.ICowbot;
import edu.udo.cs.ie.cowbots.util.GridMap;
import edu.udo.cs.ie.cowbots.util.PositionFinder;

import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.asSyntax.NumberTerm;
import jason.asSyntax.NumberTermImpl;
import jason.asSyntax.Term;

/**
 * 
 * @author dhoelzgen
 *
 */
public class exEasyFormation extends DefaultInternalAction {

	/**
	 * Simple formation internal action for testing desires and waypoints.
	 * Aligns the agents in a line, facing to the cows target
	 */
	@Override
	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
	throws Exception {
		int x = (int) ((NumberTerm) args[0]).solve();
		int y = (int) ((NumberTerm) args[1]).solve();
		int pos = (int) ((NumberTerm) args[2]).solve();

		Point wp = new Point(x, y);
		
		if (pos != 0) {
			if (pos % 2 != 0) pos = ((int)Math.ceil((double)pos / 2.0f)) *(-1);
			else pos = pos / 2;
		}

		pos *= 2;
		int factor = 2;

		String action = args[3].toString();
		
		if (ts.getUserAgArch().getAgName().equalsIgnoreCase("eve")) {
			System.err.println("eve: easy formation for action "+action);
		}

		if (action.equals("south")) {
			y-=factor;
			
			x-=pos;
		} else if (action.equals("southwest")){
			x+=factor;
			y-=factor;
			
			x-=pos;
			y+=pos;
		} else if (action.equals("west")){
			x+=factor;
			
			y-=pos;
		} else if (action.equals("northwest")){
			y+=factor;
			x+=factor;
			
			x+=pos;
			y-=pos;
		} else if (action.equals("north")){
			y+=factor;
			
			x+=pos;
		} else if (action.equals("northeast")){
			x-=factor;
			y+=factor;
			
			x+=pos;
			y+=pos;
		} else if (action.equals("east")) {
			x-=factor;
			
			y+=pos;
		} else if (action.equals("southeast")) {
			x-=factor;
			y-=factor;
			
			x-=pos;
			y-=pos;
		} else {
			System.out.println("ACHTUNG falsche Richtungsangabe: "+action);
		}
		
		ICowbot cowbot = (ICowbot) ts.getAg();
		GridMap map = cowbot.getEpistemicState().getMap();
		Point validPosition = 
			PositionFinder.getBestPositionByWPAndTarget(wp, new Point(x, y), map);

		un.unifies(args[4], new NumberTermImpl(validPosition.x));
		un.unifies(args[5], new NumberTermImpl(validPosition.y));
		
		return true;
	}

}
