package edu.udo.cs.ie.cowbots.internalActions.scout;

import java.awt.List;
import java.awt.Point;
import java.io.BufferedWriter;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Collections;

import edu.udo.cs.ie.cowbots.agent.ICowbot;
import edu.udo.cs.ie.cowbots.logic.ELPLiteral;
import edu.udo.cs.ie.cowbots.util.GridMap;
import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.asSyntax.Atom;
import jason.asSyntax.NumberTerm;
import jason.asSyntax.Term;
import jason.stdlib.print;

public class astar extends DefaultInternalAction {
	String[] path;
	GridMap map;
	ICowbot cowbot;
	boolean surroundCows = false;;
	boolean ignoreFence = false;
	boolean ignoreAlly = false;

	public boolean experimental_obstacle = false;
	public boolean experimental_cowsight = false;
	public boolean experimental_newposition = false;

	public boolean cluster_agentwall = false;

	public int addCowWeight = 100;
	public int addSightWeight = 60;

	int sX;
	int sY;
	int tX;
	int tY;

	int x;
	int y;

	int lastWorldTime = -1;

	ArrayList<Node> openSet = new ArrayList<Node>();
	ArrayList<Node> closeSet = new ArrayList<Node>();
	ArrayList<Node> nodePath = new ArrayList<Node>();

	Node[][] nodes;

	@Override
	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
	throws Exception {
		try {
			int currentWorldTime = (int) ((NumberTerm) args[5]).solve();
			if ((lastWorldTime > -1) && (lastWorldTime >= currentWorldTime)
					&& (path != null)) {
				return un.unifies(args[4], new Atom(path[0]));
			}
           
			lastWorldTime = currentWorldTime;
			long enterTime = System.currentTimeMillis();
			long exitTime = 0;
			openSet.clear();
			closeSet.clear();
			nodePath.clear();

			cowbot = (ICowbot) ts.getAg();
			map = cowbot.getEpistemicState().getMap();
			nodes = new Node[map.width()][map.height()];

			sX = (int) ((NumberTerm) args[0]).solve();
			sY = (int) ((NumberTerm) args[1]).solve();
			tX = (int) ((NumberTerm) args[2]).solve();
			tY = (int) ((NumberTerm) args[3]).solve();

			if (this.experimental_newposition) this.selectNearTarget();

			if(((int) ((NumberTerm) args[6]).solve()) !=0) surroundCows = true;
			else surroundCows = false;

			if(((int) ((NumberTerm) args[7]).solve()) !=0) ignoreFence = true;
			else ignoreFence = false;

			if(((int) ((NumberTerm) args[8]).solve()) !=0) ignoreAlly = true;
			else ignoreAlly = false;

			populateNodes(tX, tY);

			if (experimental_cowsight) {
				String direction = args[9].toString();
				x = 0;
				y = 0;
				int factor = 2;

				if (direction.equals("south")) {
					y+=factor;
				}else if (direction.equals("southwest")){
					x-=factor;y+=factor;
				} else if (direction.equals("west")){
					x-=factor;
				}else if (direction.equals("northwest")){
					y-=factor;x-=factor;
				} else if (direction.equals("north")){
					y-=factor;
				} else if (direction.equals("northeast")){
					y-=factor;x+=factor;
				} else if (direction.equals("east")) {
					x+=factor;
				} else if (direction.equals("southeast")) {
					x+=factor;y+=factor;
				} else {
					System.out.println("ACHTUNG falsche Richtungsangabe");
				}	
				setSurroundWeightsByDirection();
			}

			if(surroundCows) setCowWeights();

			path = getPath(sX, sY, tX, tY);
			
			checkPathAtSwitch();
			
			//printMap();
			// printMapScore();
			String action = path[0];

			
			
			exitTime = System.currentTimeMillis();
			// System.out.println("Astar time: " + (exitTime - enterTime) + "msec. New step -->" + path[0]);
			return un.unifies(args[4], new Atom(action));
		}catch(ArrayIndexOutOfBoundsException e){
			//TODO:Irgendwas mit dem Error machen
			//System.out.println("astar throws ArrayIndexOutOfBoundsException");
		}  
		catch (Throwable e) {
			System.out.println("astar error: " + e);
			e.printStackTrace();
		}
		return false;
	}
	
	// Simple error checking for diagonal moves near any switch along the path.
	private void checkPathAtSwitch() {

		// Agent param
		Point agentPos = new Point();
		boolean foundPosition = false;
		ArrayList<String> tempPath = new ArrayList<String>();
		String agentName = cowbot.getEpistemicState().getBeliefSet()
				.getBeliefsByPredicate("iam").get(0).getAtom().getTerm(0);
		ELPLiteral isonAgent = null;
		// Get agent position
		for (ELPLiteral e : cowbot.getEpistemicState().getBeliefSet()
				.getBeliefsByPredicate("ison")) {
			if (e.getAtom().getTerm(0).equals(agentName)) {
				isonAgent = e;
				foundPosition = true;
				break;
			}
		}

		if (foundPosition) {
			agentPos.x = Integer.parseInt(isonAgent.getAtom().getTerm(1));
			agentPos.y = Integer.parseInt(isonAgent.getAtom().getTerm(2));

			// System.out.println("Agent X: " + agentPos.x + "Agent Y: "
			// + agentPos.y);

			// Switch param, true if switch on field
			boolean westField = map.getContent(agentPos.x - 1, agentPos.y)
					.getAtom().getTerm(0).equals("switch");
			boolean eastField = map.getContent(agentPos.x + 1, agentPos.y)
					.getAtom().getTerm(0).equals("switch");
			boolean northField = map.getContent(agentPos.x, agentPos.y + 1)
					.getAtom().getTerm(0).equals("switch");
			boolean southField = map.getContent(agentPos.x, agentPos.y - 1)
					.getAtom().getTerm(0).equals("switch");

			// Check the path
			for (int i = 0; i < path.length; i++) {
				// North switch
				if (northField) {
					if (path[i].equals("northeast")) {
						tempPath.add("east");
						tempPath.add("north");
					} else if (path[i].equals("northwest")) {
						tempPath.add("east");
						tempPath.add("north");
					} else {
						tempPath.add(path[i]);
						continue;
					}
				}
				// East switch
				else if (eastField) {
					if (path[i].equals("northeast")) {
						tempPath.add("north");
						tempPath.add("east");
					} else if (path[i].equals("southeast")) {
						tempPath.add("south");
						tempPath.add("east");
					} else {
						tempPath.add(path[i]);
						continue;
					}
				}
				// South switch
				else if (southField) {
					if (path[i].equals("southeast")) {
						tempPath.add("east");
						tempPath.add("south");
					} else if (path[i].equals("southwest")) {
						tempPath.add("west");
						tempPath.add("south");
					} else {
						tempPath.add(path[i]);
						continue;
					}
				}
				// West switch
				else if (westField) {
					if (path[i].equals("southwest")) {
						tempPath.add("south");
						tempPath.add("west");
					} else if (path[i].equals("northwest")) {
						tempPath.add("north");
						tempPath.add("west");
					} else {
						tempPath.add(path[i]);
						continue;
					}
				} else
					tempPath.add(path[i]);
			}
			String[] newPath = new String[tempPath.size()];
			int index = 0;
			for (String dir : tempPath) {
				newPath[index] = dir;
				index++;
			}
		/*	if (agentName.equals("eve")) {
				try {
				BufferedWriter out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("ASTAR.txt")));
					
					for (int i = 0; i < newPath.length; i++) {
					out.write(newPath[i] + "-->");
				}
				out.newLine();
				for (int i = 0; i < path.length; i++) {
					out.write(path[i] + "-->");
				}
				out.close();
			    } catch( IOException ex ) {
		      System.out.println( ex );
		    }
			
		}*/
			path = new String[newPath.length];
			path = newPath;
		}
		 
	}

	/**
	 * Calculates path with a*, same logic as execute, but not
	 * as internal action. Uses by other internal actions and 
	 * by the planner.
	 * 
	 * @param ts TransitionSystem
	 * @param sX From X
	 * @param sY From Y
	 * @param tX To X
	 * @param tY To Y
	 * @param surroundCows
	 * @return
	 * @throws Exception
	 */
	public String[] getPath(TransitionSystem ts, int sX, int sY, int tX, int tY, boolean surroundCows) throws Exception {
	
			cowbot = (ICowbot) ts.getAg();
			map = cowbot.getEpistemicState().getMap();
			
			return this.getPath(map, sX, sY, tX, tY, surroundCows);
	}
	
	public String[] getPath(GridMap _map, int sX, int sY, int tX, int tY, boolean surroundCows)
	throws Exception {
		try {
			lastWorldTime = -1;

			openSet.clear();
			closeSet.clear();
			nodePath.clear();

			map = _map;
			nodes = new Node[map.width()][map.height()];

			this.sX = sX;
			this.sY = sY;
			this.tX = tX;
			this.tY = tY;
			this.surroundCows = surroundCows;
			this.ignoreFence = true;

			populateNodes(tX, tY);

			if(surroundCows) setCowWeights();

			path = getPath(sX, sY, tX, tY);

			return path;
		} catch (Exception e) {
			System.err.println("A* Path Error: " + e);
			e.printStackTrace();
		}
		return null;
	}

	private void populateNodes(int tX, int tY) {

		for (int i = 0; i < map.height(); i++) {
			for (int j = 0; j < map.width(); j++) {
				nodes[j][i] = new Node(j, i, tX, tY);
				if (map.getContent(j, i).getAtom().getTerm(0)
						.equals("obstacle"))
					nodes[j][i].setContent("obstacle");
				else if (map.getContent(j, i).getAtom().getTerm(0).contains(
				"cow"))
					nodes[j][i].setContent("cow");
				else if (map.getContent(j, i).getAtom().getTerm(0).equals(
				"enemy"))
					nodes[j][i].setContent("enemy");
				else if (map.getContent(j, i).getAtom().getTerm(0).equals(
				"ally")){
					// For cluster calculation, treat allies and their surrounding as obstacles
					if (this.cluster_agentwall) {
						for  (int a = -2; a <= 2; a++) { 
							for (int b = -2; b <= 2; b++) {
								try {
									nodes[j+a][i+b].setContent("obstacle");
								} catch (Exception ex) {}

							}
						}
					} else {
						nodes[j][i].setContent("ally");
						nodes[j][i].sethScore(nodes[j][i].gethScore()+100);
					}
				}
				else if (map.getContent(j, i).getAtom().getTerm(0).equals(
				"fence"))
					nodes[j][i].setContent("fence");
				else if (map.getContent(j, i).getAtom().getTerm(0).startsWith("switch"))
					nodes[j][i].setContent("switch");

				else if (j == 0 || i == 0 || j == map.width() - 1
						|| i == map.height() - 1)
					nodes[j][i].setContent("obstacle");
			}
		}

		// Try to avoid getting close to obstacles:
		// Ignore the walls on the border of the map
		if (this.experimental_obstacle) {
			for (int a = 1; a < map.height(); a++) {
				for (int b = 1; b < map.width(); b++) {
					// Higher weights in near distance
					try {
						for (int x = -2; x < 3; x++) {
							for (int y = -2; y < 3; y++) {
								int xD = a + x;
								int yD = b + y;
								if (nodes[xD][yD].getContent() != "obstacle") {
									nodes[xD][yD]
									          .sethScore(nodes[xD][yD].gethScore() + 100);
									nodes[xD][yD].computfScore();

								}
							}
						}
					} catch (Exception ex) {} // Will be handled from other obstacle...
				}
			}

		}
	}

	private void setCowWeights() {
		for (int i = 0; i < map.height(); i++) {
			for (int j = 0; j < map.width(); j++) {
				if(nodes[j][i].getContent().equals("cow")){
					Node cowNode =nodes[j][i]; 
					for (int x = -1; x < 2; x++) {
						for (int y = -1; y < 2; y++) {
							int xD = cowNode.getX() + x;
							int yD = cowNode.getY() + y;
							if (nodes[xD][yD].getContent() != "obstacle") {
								nodes[xD][yD]
								          .sethScore(nodes[xD][yD].gethScore() + addCowWeight);
								nodes[xD][yD].computfScore();

							}
						}
					}
				}
			}
		}
	}



	private void setSurroundWeightsByDirection() {
		for (int i = 0; i < map.height(); i++) {
			for (int j = 0; j < map.width(); j++) {
				if(nodes[j][i].getContent().equals("cow")){
					Node cowNode =nodes[j][i]; 

					for (int a = (-3+x); a < (4+x); a++) {
						for (int b = (-3+y); b < (4+y); b++) {

							int xD = cowNode.getX() + a;
							int yD = cowNode.getY() + b;

							try {
								if (nodes[xD][yD].getContent() != "obstacle") {
									nodes[xD][yD]
									          .sethScore(nodes[xD][yD].gethScore() + addSightWeight);
									nodes[xD][yD].computfScore();
								}
							} catch (Exception e) {
							}
						}
					}
				}
			}
		}
	}

	private void printMapScore() {
		for (int i = 0; i < map.height(); i++) {
			System.out.println("");
			for (int j = 0; j < map.width(); j++) {
				if(nodes[j][i].getContent().equals("cow")) System.out.print("ccc.");
				else if(nodes[j][i].getfScore() != 0)System.out.print(nodes[j][i].getfScore()+".");
				else System.out.print("000.");
			}
		}
		System.out.println("");
	}


	private void printMap() {
		for (int i = 0; i < map.height(); i++) {
			System.out.println("");
			for (int j = 0; j < map.width(); j++) {
				if (j == tX && i == tY)
					System.out.print("T");
				else if (j == sX && i == sY)
					System.out.print("S");
				else if (nodes[j][i].getContent().equals("*"))
					System.out.print("*");
				else if (nodes[j][i].getContent().equals("cow"))
					System.out.print("c");
				else if (nodes[j][i].getContent().equals("ally"))
					System.out.print("a");
				else if (nodes[j][i].getContent().equals("enemy"))
					System.out.print("e");
				else if (nodes[j][i].getContent().equals("obstacle"))
					System.out.print("1");
				else if (nodes[j][i].getContent().equals("fence") && (!ignoreFence))
					System.out.print("1");

				else
					System.out.print("0");

			}
		}
		System.out.println("");
	}

	private void selectNearTarget()
	{
		// Try to select another target, if target is out of map
		if (tX > map.width()-1) tX = map.width()-1;
		if (tY > map.height()-1) tY = map.height()-1;
		if (tX < 2) tX = 2;
		if (tY < 2) tY = 2;

		// TODO: Mind obstacles as well
	}

	private String[] getPath(int sX, int sY, int tX, int tY) {
		nodes[sX][sY].gScore = 0;
		closeSet.clear();
		openSet.add(nodes[sX][sY]);
		nodes[tX][tY].parent = null;

		while (openSet.size() != 0) {

			Node current = openSet.get(0);
			if (current == nodes[tX][tY]) {
				computPath(nodes[tX][tY]);
				break;
			}

			closeSet.add(current);
			openSet.remove(current);

			for (int x = -1; x < 2; x++) {
				for (int y = -1; y < 2; y++) {

					int xD = current.getX() + x;
					int yD = current.getY() + y;


					if (closeSet.contains(nodes[xD][yD]))
						continue;
					if (!nodes[xD][yD].walkAble)
						continue;

					if ((x != 0) && (y != 0))
						nodes[xD][yD].setgScore(14);
					else
						nodes[xD][yD].setgScore(10);

					boolean tempBetter = true;
					int tempScore = current.getgScore()
					+ nodes[xD][yD].getgScore();
					if (!openSet.contains(nodes[xD][yD]))
						openSet.add(nodes[xD][yD]);
					else if (tempScore < nodes[xD][yD].getgScore())
						tempBetter = true;
					else
						tempBetter = false;

					if (tempBetter) {
						nodes[xD][yD].setParent(current);
						nodes[xD][yD].gScore = tempScore;
						nodes[xD][yD].computfScore();
					}

				}
			}
			Collections.sort(openSet);

		}

		return extractPath(nodePath);
	}

	private void computPath(Node n) {
		while (n != nodes[sX][sY]) {
			nodePath.add(n);
			n = n.getParent();
			n.setContent("*");
		}

	}

	private String[] extractPath(ArrayList<Node> nodePath) {
		String[] tempPath = new String[nodePath.size()];
		int j = nodePath.size() - 1;
		for (int i = 0; i < nodePath.size(); i++) {
			if (i == 0)
				tempPath[0] = getMove(nodes[sX][sY], nodePath.get(j));
			else
				tempPath[i] = getMove(nodePath.get(j + 1), nodePath.get(j));
			j--;
		}

		return tempPath;
	}

	private String getMove(Node from, Node to) {
		if (to.x < from.x && to.y == from.y)
			return "west";
		else if (to.x > from.x && to.y == from.y)
			return "east";
		else if (to.x == from.x && to.y < from.y)
			return "north";
		else if (to.x > from.x && to.y < from.y)
			return "northeast";
		else if (to.x < from.x && to.y < from.y)
			return "northwest";
		else if (to.x == from.x && to.y > from.y)
			return "south";
		else if (to.x > from.x && to.y > from.y)
			return "southeast";
		else if (to.x < from.x && to.y > from.y)
			return "southwest";
		else
			return "skip";
	}

	class Node implements Comparable<Node> {
		private int x;
		private int y;
		int fScore = 0; // F = G + H
		int gScore = 0; // Cost from Start to Node
		int hScore = 0; // Heuristic cost from Node to Target
		String content = "";

		boolean walkAble = true;
		Node parent;

		public Node(int x, int y, int xT, int yT) {
			this.x = x;
			this.y = y;
			computhScore();
		}

		public void setParent(Node node) {
			this.parent = node;
		}

		public Node getParent() {
			return parent;
		}

		public int getX() {
			return x;
		}

		public int getY() {
			return y;
		}

		public void computhScore() {
			hScore = (Math.abs(tX - x) + Math.abs(tY - y)) * 10;
		}

		public void setContent(String s) {
			content = s;
			if (s.equals("obstacle"))
				walkAble = false;
			else if (s.equals("cow"))
				walkAble = true;
			else if (s.equals("switch"))
				walkAble = false;
			else if (s.equals("enemy"))
				walkAble = false;
			else if (s.equals("ally") && (!ignoreAlly))
				walkAble = false;
			else if (s.equals("fence") && (!ignoreFence))
				walkAble = false;

		}

		public boolean getWalkAble() {
			return walkAble;
		}

		public int getfScore() {
			return fScore;
		}

		public int getgScore() {
			return gScore;
		}

		public void setgScore(int gScore) {
			this.gScore = gScore;
		}

		public void sethScore(int hScore) {
			this.hScore = hScore;
		}

		public void computfScore() {
			this.fScore = gScore + hScore;
		}

		public String getContent() {
			return content;
		}

		public int gethScore() {
			return hScore;
		}

		@Override
		public int compareTo(Node node) {

			if (this.fScore < node.fScore)
				return -1;
			else if (this.fScore > node.fScore)
				return 1;
			else
				return 0;

		}

	}

}
