package edu.udo.cs.ie.cowbots.internalActions.scout;

import java.awt.Point;

import java.util.Collections;
import java.util.Comparator;
import java.util.LinkedList;
import java.util.List;

import edu.udo.cs.ie.cowbots.agent.ICowbot;
import edu.udo.cs.ie.cowbots.bdi.brf.BeliefSet;
import edu.udo.cs.ie.cowbots.logic.ELPLiteral;
import edu.udo.cs.ie.cowbots.planer.makePlan;
import edu.udo.cs.ie.cowbots.util.GridMap;
import jason.*;
import jason.asSyntax.*;
import jason.asSemantics.*;

import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.IntendedMeans;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;


/**
 * 
 * @author bienek, jablkowski
 *
 * This internal action is called whenever the Agent wants to check if he is near his scouting Position.
 * The result is unified in  args[5].
 */
public class calculateDistanceToDestination extends DefaultInternalAction {

	int delta = 6;
	
	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
	throws Exception {
		
		int myX= (int) ((NumberTerm) args[0]).solve(); 
		int myY= (int) ((NumberTerm) args[1]).solve(); 
		int destX= (int) ((NumberTerm) args[2]).solve(); 
		int destY= (int) ((NumberTerm) args[3]).solve(); 
		
		byte value = calculateDistance(myX,myY,destX,destY);
		un.unifies(args[4], new NumberTermImpl(value));
		return true;
	}
	
	
	/**
	 * Utility function for calculating the distance between 2 points 
	 * and comparing it to a threshold delta
	 * 
	 * @param myX	X-coordinate of Point 1
	 * @param myY	Y-coordinate of Point 1
	 * @param destX	X-coordinate of Point 2
	 * @param destY	Y-coordinate of Point 2
	 * @return	result-byte, value = 1, if the 2 Points are nearby, value = 0 else
	 *
	 */
	private byte calculateDistance(int myX,int myY,int destX, int destY){
		int diffX = Math.abs(myX-destX);
		int diffY = Math.abs(myY-destY);
		
		if (diffX+diffY <= delta) return 1;
		else return 0;
	}
}
