package edu.udo.cs.ie.cowbots.internalActions.scout;

import java.awt.Point;

import java.util.Collections;
import java.util.Comparator;
import java.util.LinkedList;
import java.util.List;

import edu.udo.cs.ie.cowbots.agent.ICowbot;
import edu.udo.cs.ie.cowbots.bdi.brf.BeliefSet;
import edu.udo.cs.ie.cowbots.logic.ELPLiteral;
import edu.udo.cs.ie.cowbots.planer.makePlan;
import edu.udo.cs.ie.cowbots.util.GridMap;
import jason.*;
import jason.asSyntax.*;
import jason.asSemantics.*;

import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.IntendedMeans;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;

/**
 * Class, which was used in the group-formation. The calling Agent
 * compares his knowledge to check whether he is allowed to form a group. 
 * No longer used by the newest version 
 * 
 * @author bienek, jablkowski
 *
 */
public class checkPriority extends DefaultInternalAction {

	ICowbot cowbot;
	BeliefSet bs;
	byte prio;
	String myId;
	int myPrio = -1;
	
	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
	throws Exception {
		
		
		cowbot = (ICowbot) ts.getAg();
		bs = cowbot.getEpistemicState().getBeliefSet();
		myId = args[0].toString();
		
		
		
		prio = check();
		un.unifies(args[1], new NumberTermImpl(prio));
		
	return true;
	}
	
	/**
	 * Utility function for calculating whether the Agent is allowed to form a group or not
	 * 
	 * @return	result-byte, value = 1, if the Agent has the best priority, value = 0 else
	 *
	 */
private byte check(){
	List<ELPLiteral> scoutlist =bs.getBeliefsByPredicate("iWantToScout");
	List<ELPLiteral> teamnumbers = bs.getBeliefsByPredicate("teamnumber");
	
	
		if (myPrio <= -1) {
			for (ELPLiteral l : teamnumbers) {
				if (l.getAtom().getTerm(0).equals(myId))
					myPrio = Integer.parseInt(l.getAtom().getTerm(1));
			}

		}
	//System.out.println("My name: " + myId + ", my Prio: " + myPrio);
	
	for(ELPLiteral l: scoutlist){
		String scoutId = l.getAtom().getTerm(0);
		int scoutPrio = Integer.MAX_VALUE;
		for(ELPLiteral k: teamnumbers){
			if (k.getAtom().getTerm(0).equals(scoutId)) scoutPrio = Integer.parseInt(k.getAtom().getTerm(1));
		}
		if (scoutPrio< myPrio) return 0;
	}
	
	return 1;
}
}
	
