package edu.udo.cs.ie.cowbots.internalActions.scout;

import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.asSyntax.NumberTerm;
import jason.asSyntax.NumberTermImpl;
import jason.asSyntax.Term;
/**
 * Class for calculating the distance of the Agent to the checkpoint
 * 
 * @author bienek, jablkowski
 *
 */

public class distanceToCP extends DefaultInternalAction{

	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
	throws Exception {
	
	int myX= (int) ((NumberTerm) args[0]).solve(); 
	int myY= (int) ((NumberTerm) args[1]).solve(); 
	int destX= (int) ((NumberTerm) args[2]).solve(); 
	int destY= (int) ((NumberTerm) args[3]).solve(); 
	
	int value = calculateDistance(myX,myY,destX,destY);
	un.unifies(args[4], new NumberTermImpl(value));
	return true;
	}
	
	/**
	 * Utility function for calculating the distance between Agent and checkpoint
	 * @param myX	X-coordinate of the Agent
	 * @param myY	Y-coordinate of the Agent
	 * @param destX	X-coordinate of the CP
	 * @param destY	Y-coordinate of the CP
	 * @return	the distance
	 *
	 */
	private int calculateDistance(int myX, int myY,int destX, int destY)
	{
		int diffX = Math.abs(myX-destX);
		int diffY = Math.abs(myY-destY);
		
		return diffX+diffY;	
	}
	
}
