package edu.udo.cs.ie.cowbots.logic;

import java.util.*;

/**
 * meta information class. meta informations provide
 * an order over extended logic programs.
 * 
 * @author Thomas
 *
 */
public class Meta implements Comparable<Meta> {

	// time: coarse sort order information
	protected int time;
	
	// index: fine-grained sort order information
	protected int index;
	
	/**
	 * default constructor
	 * 
	 */
	public Meta() {
		time = 0;
		index = 0;
	}
	
	/**
	 * simple constructor - only regard time
	 * @param time
	 */
	public Meta(int time) {
		this.time = time;
		this.index = 0;
	}
	
	public Meta(int time, int index) {
		this.time = time;
		this.index = index;
	}
	
	public int getTime() {
		return this.time;
	}
	
	public int getIndex() {
		return this.index;
	}

	@Override
	public int compareTo(Meta other) {
		int ret = 0;
		
		if (other.time == this.time) {
			if (other.index <= this.index)
				ret = 1;
			else
				ret = -1;
		} else if (other.time < this.time)
			ret = -1;
		else if (other.time > this.time)
			ret = 1;
		
		return ret;
	}
	
	@Override 
	public String toString() {
		return "time: "+this.time+"\n"+"subtime: "+this.index+"\n";
	}
}
