package edu.udo.cs.ie.cowbots.util.cluster;

import edu.udo.cs.ie.cowbots.logic.ELPLiteral;

/**
 * auxiliary class used for clustering, it extends
 * a point by adding a string field to it.
 *
 * @author Thomas
 *
 */
public class CowPosition {
	public CowPosition(ELPLiteral l) {
		this.x = Integer.parseInt(l.getAtom().getTerm(1));
		this.y = Integer.parseInt(l.getAtom().getTerm(2));
		this.name = l.getAtom().getTerm(0);
	}
	
	public CowPosition(int x, int y, String name) {
		this.x = x;
		this.y = y;
		this.name = name;
	}
	
	public int 		x,y;
	public String	name;
	
	public String getCoordKey() {
		return ""+x+"_"+y;
	}
	
	public int HDistance(CowPosition otherCow) {
		int dstX = Math.abs( x - otherCow.x);
		int dstY = Math.abs( y - otherCow.y);
		return Math.max(dstX, dstY);
	}
}