// Walking to some coordinates
/* Initial beliefs and rules */
walkfailscount(0).
walkingfailstolerance(3).
//Astar parameter
surroundCows(0).
ignoreFences(0).
ignoreAlly(0).

relateDirection(northwest, 0, 0).
relateDirection(southeast, 2, 2).
relateDirection(northeast, 2, 0).
relateDirection(southwest, 0, 2).

relateWalkAlternatives(northeast, north, east).
relateWalkAlternatives(southeast, south, east).
relateWalkAlternatives(northwest, north, west).
relateWalkAlternatives(southwest, south, west).



//debugW.
{include ("shared_knowledge.asl")}

/* Initial goals */


/* Plans */

//setzt astar parameter
+!setWalkingModi(SC,IF,IA): true <-
          -surroundCows(_);
          -ignoreFences(_);
          -ignoreAlly(_);
          +surroundCows(SC);
          +ignoreFences(IF);
          +ignoreAlly(IA).

+!debugPrintW(D): debugW <-
      ?iam(MyName);
     .concat("ASL-DEBUG: Agent:",MyName," MSG: ",D,MSG);	
	.print(MSG).
	
+!debugPrintW(D): not debugW <- true.
		
+!walkTo(X, Y):  iam(MyName) & ison(MyName,X,Y,_)     
   <-       
   .concat("Position ist schon erreicht, es gibt keinen grund auf der Stelle zu laufen! ", Msg2);
   !debugPrintW(Msg2).
   
+!walkTo(X, Y): 
    not walkingfailed 
    & walkfailscount(FailesCount) 
    & walkingfailstolerance(Maxfailes)
    & FailesCount<=Maxfailes    
   <- 
   
   .concat("Starte einen walking step", Msg1);
   !debugPrintW(Msg1);
   !doOneStep(X,Y);  
   .concat("Ende von einem walking step, aktuelle anzahl der Fehler ",FailesCount, Msg2);
   !debugPrintW(Msg2);
   !walkTo(X, Y).
        
+!walkTo(X, Y): walkingfailed <- .fail. 
           
+!doOneStep(X,Y)  : true 
       <- ?iam(MyName); 
          ?ison(MyName,X1,Y1,_);
          ?time(T);  
          //Astar Parameter        
          ?surroundCows(SC);
          ?ignoreFences(IF);
          ?ignoreAlly(IA);          
          edu.udo.cs.ie.cowbots.internalActions.scout.astar(X1,Y1,X,Y,A,T,SC,IF,IA);
         .concat("Walking action is: ", A, Msg1);
         !debugPrintW(Msg1);
         .concat("Versuche Aktion ",A, " auszufuehren", Msg2);
         !debugPrintW(Msg2);
         !careForSwitch(A);
         //A;
         .concat("Aktion ",A, " auszufuehrt", Msg3);
         !debugPrintW(Msg3);
          edu.udo.cs.ie.cowbots.internalActions.getExpectedCoordinates(X1, Y1, A, ExpX, ExpY);
          .concat("Erwartete Position x=",ExpX, " y=", ExpY, Msg4);
          !debugPrintW(Msg4);
          ?ison(MyName,ActX,ActY,_);
          .concat("Tatsaechliche Position x=",ActX, " y=", ActY,Msg5);
          !debugPrintW(Msg5);
          ?ison(MyName,ExpX, ExpY,_);        
         .concat("Position getestet, ein Schrit hat sowas von geklappt!",Msg6);
         !debugPrintW(Msg6);
         -walkfailscount(_);
         +walkfailscount(0).
            
-!doOneStep(X,Y) : not walkingfailed 
       & walkfailscount(FailesCount) 
       & walkingfailstolerance(Maxfailes)
       & FailesCount<Maxfailes   
      <- 
        .concat("ein Schritt hat nicht geklappt, aktuelle Anzahl der Fehhler war ", FailesCount,Msg1);
        !debugPrintW(Msg1);
        NewFailesCount=FailesCount+1;
        -walkfailscount(_);
        +walkfailscount(NewFailesCount).
        
 -!doOneStep(X,Y) :
         walkfailscount(FailesCount) 
       & walkingfailstolerance(Maxfailes)
       & FailesCount>=Maxfailes   
      <- 
        .concat("ein Schritt hat nicht geklappt, und die Anzahl der Fehler wurde ueberschritten",Msg1);
        !debugPrintW(Msg1);       
        -walkfailscount(_);
        +walkfailscount(0);
        +walkingfailed .
        

        
 +!careForSwitch(A) : 
 	iam(N) & ison(N, X, Y, _) 
 	& ison(S, XS, YS, _) & edu.udo.cs.ie.cowbots.internalActions.scout.distanceToCP(X, Y, XS, YS, D) 
 	& (D = 1) & switch(S) &
 	ison(F, XF, YF, _) & relateDirection(A, DX, DY) & XF = (X + (DX - 1)) 
 	& YF = (Y + (DY -1)) & fence(F)
 <-
 	.print("muss mich vom Switch wegbewegen, bevor ich auf den Fence laufen kann");
 	!stepAwayFromSwitch(A,X,Y,XS,YS).

 
                   
                   
 +!careForSwitch(A)
 <- 
 	//.print("kein Switch im Weg");
 	A.
  	
      
 +!stepAwayFromSwitch(A,X,Y,XS,YS) :
 	X = XS
 <-	//.print("xachse gleich: ",X, XS);
 	?relateWalkAlternatives(A, _, B);
 	B;
 	A.
 
   
 +!stepAwayFromSwitch(A,X,Y,XF,YS) :
 	Y = YS
 <-	//.print("yachse gleich: ",Y, YS);
 	?relateWalkAlternatives(A, B, _);
 	B;
 	A.
 
 +!stepAwayFromSwitch(A,X,_,XS,_)
 <-	//.print("sonst: ",X, XS);
 	A.