// Base ASL file used for leader agents
//
// Author: Daniel and Thomas

iAmNotBusy.
drivingCow(cow0).
cow(cow0).

{include ("Ex2Agents/exSharedKnowledge.asl")}
{include ("Ex2Agents/exWalker.asl")}
{include ("Ex2Agents/exFunk.asl")}
{include ("Ex2Agents/exActor.asl")}

// default event handler: leader is still in deep planning phase
// within the current world step. so do nothing here.
+!drivencow(C):stillplanning.
	
// do not plan if we do not have planning rights
+!drivencow(C) : time(X) & leadPrioDivisor(Y) & iam(I) & leadPlanPrio(I,Z) & X mod Y \== Z
<-
	.print("i am not a schedule for planning");
	!helped(eve,drivencow,cow0).

	
// driver plan, sets internal state to "stillplanning" to prevent
// no deliberation mode during buf to flood an agent with cowdriving
// desires.	
+!drivencow(C):true
<-	.print("Starting plan for driving ",C);
	+stillplanning;
	-drivingCow(_);
	+drivingCow(C);
	?time(Q);
	?ison(C,X2,Y2,_)[source(percept)];	
	.print("Found cow ",C," on ",X2,",",Y2);
	?corralcenter(CX,CY);
	edu.udo.cs.ie.cowbots.internalActions.experimental2.exCreateWaypoints(X2,Y2,CX,CY,A);
	// NEW DYNAMIC PLANNER TEST
	edu.udo.cs.ie.cowbots.internalActions.experimental2.exCreatePlan(X2,Y2,CX,CY);
	-stillplanning;
	.print("Sending generated orders...");	
	!sendOrders;
	!!helped(eve,drivencow,C).
	
// rescue plan to not stall eve when attempting another plan	
-!drivencow(C):true
<-	-stillplanning;
	.print("Stopping drivencow").	
	
-!sendOrders : true
<-	.print("Could not send orders.").	
	
+!scouted : not scouttarget(X,Y)
<-	.print("Start scouting, calculating new scout destination.");
	edu.udo.cs.ie.cowbots.internalActions.experimental2.exRandomScoutPosition(X,Y);
	+scouttarget(X,Y).
	
+!scouted : scouttarget(X,Y)
	& not edu.udo.cs.ie.cowbots.internalActions.experimental2.exIsValidScoutDestination(X,Y)
<-	.print("Scout destination has become invalid.");
	-scouttarget(X,Y).

// do not plan if we do not have planning rights
+!scouted : time(X) & leadPrioDivisor(Y) & iam(I) & leadPlanPrio(I,Z) & X mod Y \== Z
<-
	.print("i am not a schedule for planning");
	!helped(eve,drivencow,cow0).

+!scouted : scouttarget(X,Y)
<-	.print("Starting plan for scouting");
	+stillplanning;
	// Start planning process
	.print("Found my friends, starting planner...");
	?corralcenter(CX,CY);
	edu.udo.cs.ie.cowbots.internalActions.experimental2.exCreateWaypoints(X,Y,CX,CY,A);
	edu.udo.cs.ie.cowbots.internalActions.experimental2.exCreatePlan(X,Y,X,Y);
	-stillplanning;
	.print("Sending generated orders...");	
	!sendOrders;
	!!helped(eve,drivencow,cow0).
	
-!scouted:true
<-	-stillplanning;
	.print("Stopping scouting").
