//{include ("walker.asl")} 
{include ("exDooropenerHelper.asl")} 
{include ("cbfunk.asl")} 


// rotateDirection(Dir, CD, CE) rotating a given cardinal direction CD in the direction Dir results in cardinal direction CE  
rotateDirection(right, north, east).
rotateDirection(right, east, south).
rotateDirection(right, south, west).
rotateDirection(right, west, north).
rotateDirection(left, north, west).
rotateDirection(left, east, north).
rotateDirection(left, south, east).
rotateDirection(left, west, south).


// uebersetzt bewegungsrichtung in koordinatenaenderung
relateDirection(north, 1, 0).
relateDirection(south, 1, 2).
relateDirection(west, 0, 1).
relateDirection(east, 2, 1).
relateDirection(northeast, 2, 0).
relateDirection(northwest, 0, 0).
relateDirection(southeast, 2, 2).
relateDirection(southwest, 0, 2).



// toggleSwitch(Side, CD, X, Y) when toggling a switch from Side at a gate you are facing CD, 
// you have to step X-1 and Y-1 back from the switch coordinates to trigger it
toggleSwitch(outside, north, 1, 2).
toggleSwitch(outside, east, 0, 1).
toggleSwitch(outside, south, 1, 0).
toggleSwitch(outside, west, 2, 1).
toggleSwitch(inside, north, 1, 0).
toggleSwitch(inside, east, 2, 1).
toggleSwitch(inside, south, 1, 2).
toggleSwitch(inside, west, 0, 1).


// laesst alle helper zu dooropenern werden 
+!initiateAgents(HelperList)
<-	.send(HelperList, tell, becomeDooropener).


// Wenn fencewp an zweiter stelle: das hier aufrufen!
// Wenn fencewp & tor offen: leadmarching

// plan fuer das oeffnen eines zauns von aussen 
+!dooropeningOutside(HelperList) : true
<-	.print("Starting Dooropening, helperlist is", HelperList);
	!buildDooropenerLiterals(HelperList);
	//.print("helperlist build");
	?agentGroup(Ag, Bg);
	.print("agentGroup are ", Ag, Bg);
	-+doorOpenerToggle(Ag, Bg);
	+doorOpenerToggle(Bg, Ag);
	?kwaypoint(fenceopenwp,S,Wx,Wy,FD,TDirection);
	.print("got waypoint");
	-+currentDirection(TDirection);
	!getFence(Wx, Wy, TDirection);
	?currentFence(F,Fx,Fy);
	.print("got fence",F);
	!buildTempGate(F,Fx,Fy);
	?tempGate(Fx,Fy,G);
	.print("got tempGate",G);
	!leadHandleSwitch(Ag, Bg);
	.print("dooropeningoutside fertig").


-!dooropeningOutside(HelperList):true
<- .print("can't open door, and don't know why").

	
// wenn es nur 1 agenten gibt (den leader), dann kann dieser nicht alleine durch das gatter gelangen
+!buildDooropenerLiterals(HelperList) : .length(HelperList, AgentCount) & AgentCount = 0 
<- .print("Dooropening alleine nicht moeglich").

// erzeugt hilfliterale, die die spaetere koordination erleichtern agentGroup - die aeu�ersten Agenten, wingAgents - 
//je einer der aeusseren agenten und sein naechster nachbar
// bei kleinen gruppen gibt es ueberschneidungen	
+!buildDooropenerLiterals(HelperList)
<-	.length(HelperList, AgentCount);
	.nth(AgentCount - 1, HelperList, Ag);
	.nth(0, HelperList, Bg);
	.print(Ag, " and ", Bg, " are searching");
	-+agentGroup(Bg, Ag);
	!buildAgentWing(HelperList).
	
// erzeugt die oben beschriebenen wingAgents
+!buildAgentWing(HelperList)
<-
	.length(HelperList, AgentCount);
	.nth(AgentCount - 1, HelperList, Ag);
	.nth(AgentCount - 2, HelperList, Bg);
//	.print(Ag, " and ", Bg, " are a Wing");
	-agentWing(_,_);
	+agentWing(Ag, Bg);
	+agentWing(Bg, Ag);
	.nth(0, HelperList, Cg);
	.nth(1, HelperList, Dg);
//	.print(Cg, " and ", Dg, " are a Wing");
	+agentWing(Dg, Cg);
	+agentWing(Cg, Dg).
	
+!dooropeningInside(HelperList) :
	closestAgent(ClosestAgent) & arrivedAtSwitch(_, _)[source(ClosestAgent)] & agentWing(ClosestAgent, WingAgent)
	& arrivedAtSwitch(_, _)[source(WingAgent)]
	
<-	
	.print("mache ClosestAgent wieder verfgbar");
	-arrivedAtSwitch(_, _)[source(ClosestAgent)];
	-isBusy(ClosestAgent).


+!dooropeningInside(HelperList) :
	closestAgent(ClosestAgent) & agentWing(ClosestAgent, WingAgent)
	& arrivedAtSwitch(_, _)[source(WingAgent)] & not arrivedAtSwitch(_, _)[source(ClosestAgent)]
	
<-	
	.print("pruefe ob ClosestAgent im Pferch ist");
	
	?currentFence(Fen,Xf,Yf);
	?currentDirection(D4);
	!askIfPassed(HelperList, Fen, Xf, Yf, D4, 1);
	-+isPassed(Fen,Xf,Yf,D4);
	!fencePassed;
	-isPassed(Fen,Xf,Yf,D4);
	!checkIfPassed;
	!handleWingAgent(WingAgent).
	

+!handleWingAgent(WingAgent) : allAgentsPassed
<-
	.print("alle Agenten im Pferch, mache WingAgent verfgbar");
	-arrivedAtSwitch(_, _)[source(WingAgent)];
	-isBusy(WingAgent);
	-kwaypoint(fenceopenwp,_,_,_,_,_); // TODO: SEHR UNSAUBER!!
	.abolish(whiledooropening(_));
	!abolishDoorOpenerLeaderPlan.

+!handleWingAgent(WingAgent)
<-
	.print("noch nicht alle durch das Gatter gelaufen").


// plan fuer das oeffnen eines zauns von innen 
+!dooropeningInside(HelperList) : allAgentsPassed
<-	
	.print("dooropeningInside");
	//?step(Step);
	//?agentGroup(Ag, Bg);
	//.print(Ag,Bg);
	//?kwaypoint(_,Step,_,_,D,_);
	//.print(D);
	?currentDirection(D);
	.print("Direction: ", D);
	
	?currentFence(F,Fx,Fy);
	.print("Fence: ", F, Fx, Fy);
	
	!buildTempGate(F, Fx, Fy);
	!getCurrentSwitch(F,Fx,Fy);
	?currentSwitch(S, X, Y);	
	.print("Switch: ", S, X, Y);
	
	//.print(S, X, Y);
	?closestAgent(ClosestAgent);
	.print(ClosestAgent);
	?agentWing(ClosestAgent, WingAgent);
	.print(WingAgent);

	?gateOrthogonal(Ortho);
	.print(Ortho);
		
	?toggleSwitch(inside, Ortho, X3, Y3);
	
	//?toggleSwitch(inside, D, X3, Y3);
	//.print(X3,Y3);
	.print("Schicke ", WingAgent, " zu (", X + X3 -1, ",", Y + Y3 -1, ")");
	.wait(100);
	!leaddooropening(WingAgent, X + X3 - 1, Y + Y3 - 1).
	
	//!leadStepAwayFromSwitch(Ag, Direction, Sdx);
	
	
	/*
	
 	?iam(N);
	.print("Schicke ", ClosestAgent, " in den Pferch");
	.send(ClosestAgent, tell, getinformation(N, Step));
	!waitForAllAgentsInFormation(1, ClosestAgent);
	.print(ClosestAgent, " ist im Pferch angekommen");
	.abolish(information(_, _));	   	
	
	.print("Schicke ", WingAgent, " in den Pferch");
	.send(WingAgent, tell, getinformation(N, Step));
	!waitForAllAgentsInFormation(1, WingAgent);
	.print(WingAgent, " ist im Pferch angekommen");
	.abolish(information(_, _));	   	
	
	

	.print("Alle Agenten in den Pferch geschickt");
	
	
	-switchDetected(S, X, Y, T)[source(Cg)];
	//-relativeDirection(_,_,_).
	-doorOpenerToggle(_,_);
	-closestAgent(_);
	-farestAgent(_);
	-agentGroup(Ag,Bg);
	-tempGate(_,_,_);
	-currentSwitch(S,X,Y);
	-whiledooropening(_);
	-isBusy(_).	*/
	
	
+!dooropeningInside(HelperList) : not allAgentsPassed
<- .print("dooropeningInside wartet noch auf Agenten").



// koordiniert die agenten bei der suche nach einem switch
+!leadHandleSwitch(Ag, Bg) : currentFence(F,X,Y) & tempGate(X,Y,G) & not (tempGate(Sx,Sy,G) & ison(S,Sx,Sy,_) & switch(S))
			&currentDirection(Direction)
<-	.print("start handleSwitch, no switch known");
	//Rechts und links relativ zur akt. Bewegungsrichung
	.print("sende ", Ag, " dass er einen Switch in Richtung rechts suchen soll");
	.send(Ag, tell, startLookingForSwitch(F, X, Y, Direction, right));
	.print("sende ", Bg, " dass er einen Switch in Richtung links suchen soll");
	.send(Bg, tell, startLookingForSwitch(F, X, Y, Direction, left));
	+isBusy(Ag);
	+isBusy(Bg).

	
+!getFence(Wx, Wy, Direction) : ison(F, Wx, Wy, _) & (switch(F) | fence(F))
<-	-+currentFence(F, Wx, Wy).
	
+!getFence(Wx, Wy, Direction) : relateDirection(Direction, Xoff, Yoff)
<-	
	!getFence((Wx + (Xoff - 1)), (Wy + (Yoff -1)), Direction).
	
// switch oeffnen
+!leadHandleSwitch(Ag, Bg) : currentFence(F,X,Y) & tempGate(X,Y,G) & tempGate(Sx,Sy,G)&
			 ison(S,Sx,Sy,_) & switch(S) & not arrivedAtSwitch(Sx,Sy) & not closestAgent(Cg)
<- .print("start handleSwitch, start open switch");
	
	?currentDirection(Direction);
	!getClosestAgent(Ag, Bg, S, Sx, Sy);
	?closestAgent(ClosestAgent);
	
	!buildTempGate(S, Sx, Sy);
	
	?gateAxis(Axis);
	?getGateOrthogonal(Axis, Direction, Ortho);
	+gateOrthogonal(Ortho);	
	
	?toggleSwitch(outside, Ortho, X2, Y2);
	.print("Schicke ", ClosestAgent, " zu (", Sx + X2 -1, ",", Sy + Y2 -1, ")");
	-(ClosestAgent);
	+isBusy(ClosestAgent);
	
	!leaddooropening(ClosestAgent, Sx + X2 -1 , Sy + Y2 - 1);
	
	//farer agent is not busy any more
	?farestAgent(Fg);
	-isBusy(Fg);
	.print("farest agent ",Fg," is not busy any more");
	.wait(100);
	
	.print("LeadHandleSwitch finished").
		
//Tr ffnen, Agent ist schon unterwegs		
+!leadHandleSwitch(Ag, Bg) : currentFence(F,X,Y) & tempGate(X,Y,G) & tempGate(Sx,Sy,G)&
			 ison(S,Sx,Sy,_) & switch(S) & not arrivedAtSwitch(Sx,Sy) & closestAgent(ClosestAgent)
<- .print("start handleSwitch, continue open switch");
	
	!buildTempGate(S, Sx, Sy);	
	
	?gateOrthogonal(Ortho);
	?toggleSwitch(outside, Ortho, X2, Y2);
	.print("Schicke ", ClosestAgent, " zu (", Sx + X2 -1, ",", Sy + Y2 -1, ")");
	+isBusy(ClosestAgent);	
	!leaddooropening(ClosestAgent, Sx + X2 -1 , Sy + Y2 - 1);
	.wait(100);
	.print("LeadHandleSwitch finished").
		

//Switch ist offen
+!leadHandleSwitch(Ag, Bg) : currentFence(F,X,Y) & tempGate(X,Y,G) & tempGate(Sx,Sy,G)&
			 ison(S,Sx,Sy,_) & switch(S) &  arrivedAtSwitch(Sx,Sy)[source(Cg)] 	
<-	.print("start handleSwitch, switch open, trying to march");
	-+isAtSwitch(Cg).
	
		
// fehlerbehandlung fuer llfs
-!leadHandleSwitch(Ag, Bg):true
<-	.print("Fehler bei leadHandleForSwitch");
	?currentFence(A,B,C);
	.print("fehler, currentfence ist",A,B,C);
	?kwaypoint(U,1,W,X,Y,Z);
	.print("wegpunkt ist:", U,W,X,Y,Z);
	-wait(100).
	
	
// warteschleife des leaders bei llfs, wartet auf erfolgsmeldung der switchsuche
+!switchlookingPending(Ag, Bg, Direction)
<-
	.print("warte auf Erfolg (lfs) von ", Ag, " und ", Bg);
	.wait(2000);
	!switchlookingPending(Ag, Bg, Direction).
	
	
// frage die agenten Ag und Bg nach ihrer Distanz zu Switch S (momentan werden auch noch die koordinaten uebergeben)
// und vergleicht diese
+!getClosestAgent(Ag, Bg, S, X, Y) 
<-	
	.send(Ag, tell, checkDistance(S, X, Y));
	.send(Bg, tell, checkDistance(S, X, Y));
	!getDistancePending(Ag, Bg, S, X, Y);
	
	!compareAgentDistance(Ag, Bg, S, X, Y); 
		
	-distanceToSwitch(_,_,_,_,_,_).
	
	
	
	
// vergleicht die distanzen von Ag und Bg und traegt den naeheren Agenten in das Literal closestAgent ein
+!compareAgentDistance(Ag, Bg, S, X, Y) : distanceToSwitch(S, X, Y, DistA, _)[source(Ag)] & distanceToSwitch(S, X, Y, DistB, _)[source(Bg)] &
(DistA <= DistB)
<-
	.print("Naeherer Agent: ", Ag);
	+closestAgent(Ag);
	+farestAgent(Bg).

// vergleicht die distanzen von Ag und Bg und traegt den naeheren Agenten in das Literal closestAgent ein	
+!compareAgentDistance(Ag, Bg, S, X, Y) : distanceToSwitch(S, X, Y, DistA, _)[source(Ag)] & distanceToSwitch(S, X, Y, DistB, _)[source(Bg)] &
(DistA > DistB)
<-
	.print("Naeherer Agent: ", Bg);
	+closestAgent(Bg);
	+farestAgent(Ag).

	
// Plan fuer den Eingang der Distanzen der beiden Agenten
+!getDistancePending(Ag, Bg, S, X, Y) : 
	distanceToSwitch(S, X, Y, DistA, _)[source(Ag)] & distanceToSwitch(S, X, Y, DistB, _)[source(Bg)] 	
<-	
	.print(Ag, " sagt mir er hat Abstand ", DistA, " zu ", S);
	.print(Bg, " sagt mir er hat Abstand ", DistB, " zu ", S).
	
// warteschleife f�r das Warten auf die Distanzen der beiden Agenten
+!getDistancePending(Ag, Bg, S, X, Y) 
<-	
	.print("Warte auf Distanzen");
	.wait(1000);
	!getDistancePending(Ag, Bg, S, X, Y).

-!getDistancePending(Ag, Bg, S, X, Y)
<-
	.print("getDistancePending fehlgeschlagen.").
	
	
// Plan fuer die Koordination einen Agenten zum Switch zu schicken (isAtSwitch wird nicht geloescht, da man die Information spaeter noch benoetigt)
+!leaddooropening(Ag, X, Y)
<-	+isBusy(Ag);
	.print("sende ", Ag, " dass er den Switch oeffnen soll");
	.send(Ag, tell, openSwitch(X, Y)).
	


+!getCurrentSwitch(F,Fx,Fy) : 
	ison(S, Sx, Sy, _) & switch(S) & tempGate(Sx, Sy, Gn) & tempGate(Fx, Fy, Gn)
<-
	-+currentSwitch(S, Sx, Sy).


+!getCurrentSwitch(F,Fx,Fy) : true
<-
	.print("Fehler: kein Switch zu Gate gefunden.").


+!leadmarching(HelperList, Pos): not (.length(HelperList, AgentCount) & AgentCount <= (Pos - 1)) & .nth(Pos - 1, HelperList, Ag) & not (isAtSwitch(Ag) | iam(Ag))
<-  .print("sende ", Ag, " getinformation"); 

  	?helper(_, Ag, C);
  	?waypointCounter(WC);
  	?kwaypoint(_,WC,XCOOR, YCOOR, FromDir,ToDir);
  	.send(Ag, tell, waypoint(0, scouted, 0, WC, XCOOR, YCOOR, FromDir, ToDir, 0, 0, 0));
	!leadmarching(HelperList, Pos+1). 	
	
       	
+!leadmarching(HelperList, Pos): not (.length(HelperList, AgentCount) & AgentCount <= (Pos - 1)) & .nth(Pos - 1, HelperList, Ag) & isAtSwitch(Ag)
<-  .print(Ag, " ist bereits mit einem Switch beschaeftigt");
	!leadmarching(HelperList, Pos+1).
	
	
+!leadmarching(HelperList, Pos): not (.length(HelperList, AgentCount) & AgentCount <= (Pos - 1)) & .nth(Pos - 1, HelperList, Ag) & iam(Ag)
<-  .print("ich laufe erst nachher los");
	!leadmarching(HelperList, Pos+1).
	
	
+!drivencow(C): whiledooropening(_) //& not fenceclosewpreached
<-	.print("Continuing drivencow while dooropening");
	?time(Q);
	.print("Asking for help...");
	edu.udo.cs.ie.cowbots.planer.getIntensityForLastGoal(I);
	.broadcast(tell, help(drivencow,C,I,Q));
	?iam(Me);
	-accepted(_,_,_);
	+accepted(drivencow,C,Q);
	.wait(100);
	.print("Looking for wayoint...");
	?kwaypoint(fenceclosewp,S,X,Y,F,D);
	-+waypointCounter(S);
	.print("Waypoint has target ",X,",",Y);
	edu.udo.cs.ie.cowbots.planer.makePlan(dynamic,X,Y,C); 
	//Ziel ist automatisch owncorral, X,Y unntig
	.print("planned");
	!dynamic;
	.print("sent all WPs");
	edu.udo.cs.ie.cowbots.internalActions.experimental.exEasyFormation(X, Y, 0, D, ExpX, ExpY);
	.print("Start walking to",ExpX,",",ExpY);
	edu.udo.cs.ie.cowbots.planer.makePlan(reach,ExpX,ExpY,Me);
	!reach;
	.print("Reached.");
	?ison(Me,Xme,Yme,Q);
	!testwpreached(S,Xme,Yme,ExpX,ExpY);
	.wait(100).	

/*
	+!drivencow(C): whiledooropening(_) & fenceclosewpreached
<-	.print("Continuing drivencow while dooropening, fenceclosewp is reached");
	?time(Q);
	.print("Asking for help...");
	edu.udo.cs.ie.cowbots.planer.getIntensityForLastGoal(I);
	.broadcast(tell, help(drivencow,C,I,Q));
	?iam(Me);
	-accepted(_,_,_);
	+accepted(drivencow,C,Q);
	.wait(100);
	.print("Looking for wayoint...");
	?kwaypoint(fenceclosewp,S,X,Y,F,D);
	?kwaypoint(_,S+1,X1,Y1,F1,D1);
	-+waypointCounter(S+1);
	.print("Waypoint has target ",X1,",",Y1);
	edu.udo.cs.ie.cowbots.planer.makePlan(dynamic,X1,Y1,C); 
	//Ziel ist automatisch owncorral, X,Y unntig
	.print("planned");
	!dynamic;
	.print("sent all WPs");
	edu.udo.cs.ie.cowbots.internalActions.experimental.exEasyFormation(X1, Y1, 0, D1, ExpX, ExpY);
	.print("Start walking to",ExpX,",",ExpY);
	edu.udo.cs.ie.cowbots.planer.makePlan(reach,ExpX,ExpY,Me);
	!reach;
	.print("Reached.");
	.wait(100).	
*/
	
+!sendWP(Ag,C,Num,Anz): not isBusy(Ag)&  whiledooropening(1)
<- 	.print(Ag," gets a fenceopenwp ");
	?kwaypoint(fenceopenwp,S,X,Y,F,D);
	?time(Q);
	.send(Ag,tell,waypoint(startwp,drivencow,C,S,X,Y,F,D,Num,Anz,Q)).
	
+!sendWP(Ag,C,Num,Anz): not isBusy(Ag)&  whiledooropening(2)
<- 	.print(Ag," gets a fenceclosewp ");
	?kwaypoint(fenceclosewp,S,X,Y,F,D);
	?time(Q);
	.send(Ag,tell,waypoint(startwp,drivencow,C,S,X,Y,F,D,Num,Anz,Q)).	
	
+!sendWP(Ag,C,Num,Anz): not isBusy(Ag)&  ( whiledooropening(3) | whiledooropening(4) )
<- 	.print(Ag," gets next wp ");
	?kwaypoint(fenceclosewp,S,_,_,_,_);
	//?kwaypoint(_,S+1,X,Y,F,D);
	?kwaypoint(_,S,X,Y,F,D);
	?time(Q);
	.send(Ag,tell,waypoint(startwp,drivencow,C,S,X,Y,F,D,Num,Anz,Q)).
	

+!testwpreached(Number,Xstart,Ystart,Xgoal,Ygoal): Xstart=Xgoal & Ystart=Ygoal
<- .print("fenceclosewp is reached, going on");
	+wpReached(Number).
	
+!testwpreached(Number,Xstart,Ystart,Xgoal,Ygoal): not (Xstart=Xgoal & Ystart=Ygoal)
<- .print("WP not jet reached");
	-wpReached(Number).
	
	
+!askIfPassed(HelperList, F, Fx, Fy, D, Pos) : .length(HelperList, AgentCount) & AgentCount <= (Pos - 1)
<- .print("An alle Agenten verschickt").
	
+!askIfPassed(HelperList, F, Fx, Fy, D, Pos) :
	not (.length(HelperList, AgentCount) & AgentCount <= (Pos - 1)) & .nth(Pos - 1, HelperList, Ag) 
	& not (arrivedAtSwitch(_,_)[source(Ag)] | iam(Ag))
<- 	.send(Ag, tell, isPassed(F, Fx, Fy, D));
	!askIfPassed(HelperList, F, Fx, Fy, D, Pos+1).
		

+!askIfPassed(HelperList, F, Fx, Fy, D, Pos) :
	not (.length(HelperList, AgentCount) & AgentCount <= (Pos - 1)) & .nth(Pos - 1, HelperList, Ag) 
	& arrivedAtSwitch(_,_)[source(Ag)]
<- 	.print(Ag, " ist bereits mit einem Switch beschaeftigt");
	-gatePassed(_, _, _, _)[source(Ag)]; 
	!askIfPassed(HelperList, F, Fx, Fy, D, Pos+1).

+!askIfPassed(HelperList, F, Fx, Fy, D, Pos) :
	not (.length(HelperList, AgentCount) & AgentCount <= (Pos - 1)) & .nth(Pos - 1, HelperList, Ag) 
	& isBusy(Ag)
<- 	.print(Ag, " ist bereits beschaeftigt"); 
	-gatePassed(_, _, _, _)[source(Ag)];
	!askIfPassed(HelperList, F, Fx, Fy, D, Pos+1).
	
	
+!askIfPassed(HelperList, F, Fx, Fy, D, Pos) :
	not (.length(HelperList, AgentCount) & AgentCount <= (Pos - 1)) & .nth(Pos - 1, HelperList, Ag) 
	& iam(Ag)
<- 	.print(Ag, " bin ich selbst");
	!fencePassed;
	!askIfPassed(HelperList, F, Fx, Fy, D, Pos+1).


	
	
// alle Helfer auer ffner sind durch
+!checkIfPassed : not gatePassed(F,Fx,Fy,false) 
	& .count(gatePassed(_,_,_,_)[source(Ag)], PassedCount)
	& .count(helper(_,_,_), HelperCount) 
	& .count(arrivedAtSwitch(_,_), BusyCount)
	& PassedCount = ((HelperCount +1) - BusyCount)
<-	.print("alle Helfer durch"); 
	-+whiledooropening(4);
	.print("neue dooropeningphase: 4");
	//.abolish(gatePassed(_,_,_,_));
	-+allAgentsPassed.
	
+!checkIfPassed : not gatePassed (F,Fx,Fy,false)
<- .print("keiner nicht durch");
	.count(gatePassed(_,_,_,_)[source(Ag)], PassedCount);
	.count(helper(_,_,_), HelperCount) ;
	.count(isBusy(_), BusyCount);
	.print("PassedCount ", PassedCount, " HelperCount ", HelperCount, " BusyCount ", BusyCount);
	-allAgentsPassed.
	
+!checkIfPassed: true
<-	
	.print("nicht alle Helfer durch");
	-allAgentsPassed;
	.wait(100).	
	

-!checkIfPassed : true
<- .print("Fehler in checkIfPassed").
	
+!abolishDoorOpenerLeaderPlan : true
<- 
	
  !debugprint("Im in abolishDoorOpenerLeaderPlan : true" );
  !abolishDoorOpeningHelperPlan;
  -doorOpenerToggle(_, _);
  -agentGroup(_,_);
  -currentFence(_,_,_);
  -currentSwitch(_, _, _);
  -agentWing(_, _);
  -closestAgent(_);
  -farestAgent(_);
  -whiledooropening(_);
  -isBusy(_);
  -isAtSwitch(_);
  -distanceToSwitch(_,_,_,_,_,_);
  -fenceclosewpreached;
  -switchDetected(_, _, _, _);
  -gatePassed(_, _, _, _);
  -currentDirection(_);
  -switchDetected(_,_,_).
  
  
  
+gatePassed(F, Fx, Fy, true)[source(Ag)]
<-  -gatePassed(F, Fx, Fy, false)[source(Ag)].
  
+gatePassed(F, Fx, Fy, false)[source(Ag)]
<-  -gatePassed(F, Fx, Fy, true)[source(Ag)].
	 
	
